from PyQt4 import QtCore, QtGui

import defaults



class Line:
	def __init__(self, scene, image, axes_number, ui, comboList):
		self.scene = scene
		self.image = image
		self.axes_number = axes_number
		self.ui = ui
		self.comboList = comboList
		self.selection = []

	def QTColorGet(self, color):
		if (color == "#FFFFFF"):
			return QtCore.Qt.white
		if (color == "#000000"):
			return QtCore.Qt.black
		if (color == "#FF0000"):
			return QtCore.Qt.red
		if (color == "#0000FF"):
			return QtCore.Qt.blue
		if (color == "#000080"):
			return QtCore.Qt.darkBlue
		if (color == "#FFFF00"):
			return QtCore.Qt.yellow
		if (color == "#00FF00"):
			return QtCore.Qt.green
		if (color == "#800000"):
			return QtCore.Qt.darkRed
		if (color == "#008000"):
			return QtCore.Qt.darkGreen
		if (color == "#000080"):
			return QtCore.Qt.darkBlue
		if (color == "#00FFFF"):
			return QtCore.Qt.cyan
		if (color == "#008080"):
			return QtCore.Qt.darkCyan
		if (color == "#FF00FF"):
			return QtCore.Qt.magenta
		if (color == "#800080"):
			return QtCore.Qt.darkMagenta
		if (color == "#808000"):
			return QtCore.Qt.darkYellow
		if (color == "#a0a0a4"):
			return QtCore.Qt.gray
		if (color == "#808080"):
			return QtCore.Qt.darkGray
		if (color == "#c0c0c0"):
			return QtCore.Qt.lightGray

		print "*** Color not found in QT palette, default to black"
		return QtCore.Qt.black

	def addLines(self, show_max, axislimits=None):
		pen = QtGui.QPen()
		self.backupRows=[]
		self.backupRows.append([])
		#print str(axislimits)
		parentcontainer = []
		linecounter = self.axes_number-1
		plotnb = -1
		parentDict={}
		row = self.ui.tableWidget.rowCount()
		self.ui.tableWidget.insertRow(row)
		for line in self.image['lines']:
			
			if not line['hidden']:
				plotnb=plotnb+1
				linecounter = linecounter + 1
				qtcolor = self.QTColorGet(line['color'])
				pen.setColor(qtcolor)
				pen.setWidthF(line['penwidth'])
				currentLine = lineItem(plotnb * defaults.axiswidth, self.image['height'] - line['y1'], (plotnb + 1) *
							 defaults.axiswidth, self.image['height'] - line['y2'])
				currentLine.setToolTip("%s -> %s" % (line['x1_strval'], line['x2_strval']))
				currentLine.setPen(pen)
				currentLine.setCursor(QtCore.Qt.OpenHandCursor)
				self.scene.addItem(currentLine)
				self.ui.tableWidget.setItem(row, plotnb, QtGui.QTableWidgetItem(line['x1_strval']))
				self.backupRows[row].append(line['x1_strval'])
				parentcontainer.append(linecounter)
				if plotnb == self.axes_number-2:
					self.ui.tableWidget.setItem(row, plotnb+1, QtGui.QTableWidgetItem(line['x2_strval']))
					self.backupRows[row].append(line['x2_strval'])
					row = self.ui.tableWidget.rowCount()
					self.backupRows.append([])
					self.ui.tableWidget.insertRow(row)
					for each in parentcontainer:
						parentDict[each]=parentcontainer
					del parentcontainer					
					parentcontainer = []
					plotnb=-1

		count = 0 #Set the headers of tableWidget
		for each in self.comboList:
			self.ui.tableWidget.horizontalHeaderItem(count).setText(each.currentText().__str__())
			count = count + 1
		#remove a unused row
		self.ui.tableWidget.removeRow(row)
		#Sets a backup control value, to slider hide/show correctly and efficient
		self.hideValue = linecounter-(self.axes_number-1)/(self.axes_number-1)
		#Gets items of scene only 1 time
		self.graph_item = self.scene.items()
		self.scene.getItems(self.graph_item,self.axes_number)
		self.graph_size= len(self.graph_item)

		for each in parentDict:
			count = 0
			parentList = []
			for i in parentDict[each]:
				variant = QtCore.QVariant(i)
				self.graph_item[each].setData(count,variant)
				parentList.append(self.graph_item[i])
				#self.graph_item[each].setFlag(QtGui.QGraphicsItem.ItemIsSelectable, True)
				count=count+1
			self.graph_item[each].setParents(parentList, self.graph_item)
			del parentList


	def removeLines(self):
		itemnb=0
		for each in self.graph_item:
			if itemnb>=self.axes_number:
				self.scene.removeItem(each)
			itemnb=itemnb+1


	def showLines(self, show_max):
		itemnb = 0
		counter = self.hideValue*(self.axes_number-1)
		while(counter<=show_max*(self.axes_number-1)+(self.axes_number-1)):
			if (counter < self.graph_size):
				self.graph_item[counter].show()
			counter=counter+1

		if(show_max>=self.hideValue):
			for i in range(self.hideValue,show_max):
				self.ui.tableWidget.insertRow(i)
				plotnb=-1
				for each in self.backupRows[i]:
					plotnb=plotnb+1
					self.ui.tableWidget.setItem(i, plotnb, QtGui.QTableWidgetItem(each))
		self.hideValue=show_max


	def update_lines_view(self, value):
		count_item=0
		for item in self.graph_item:
			if (count_item >= self.axes_number and (count_item>value*(self.axes_number-1)+self.axes_number-1)):
				item.hide()
			count_item = count_item+1
		reversed_range=range(value,self.hideValue)
		reversed_range.reverse()
		for i in reversed_range:
			self.ui.tableWidget.removeRow(i)
		self.showLines(value)

	def clean(self):
		del self.backupRows
		self.removeLines()
		del self.graph_item
		del self.graph_size

		reversed_range=range(0,self.ui.tableWidget.rowCount()+1)
		reversed_range.reverse()
		for i in reversed_range:
			self.ui.tableWidget.removeRow(i)


	def maxLinesGet(self):
		linecounter = 0
		for line in self.image['lines']:
			linecounter = linecounter + 1
		return linecounter

	def decreaseWidth(self):
		count = 0
		for each in self.graph_item:
			if count > self.axes_number-1:
				each.decreaseWidth()
			count = count + 1
	def increaseWidth(self):
		count = 0
		for each in self.graph_item:
			if count > self.axes_number-1:
				each.increaseWidth()
			count = count + 1

	def selectionUpdate(self):
		tmpselection = self.scene.selectedItems()
		count = 0
		pen = QtGui.QPen()
		for each in self.selection:
			qtcolor = self.QTColorGet(self.image['lines'][each-self.axes_number]['color'])
			pen.setColor(qtcolor)
			pen.setWidthF(self.image['lines'][each-self.axes_number]['penwidth'])
			self.graph_item[each].setPen(pen)

		del self.selection
		self.selection = []

		for each in tmpselection:
			for i in range(0,self.axes_number-1):
				tmp = each.data(i).toInt()[0]
				self.graph_item[tmp].setSelected(True)
				self.selection.append(tmp)
				pen = QtGui.QPen(QtCore.Qt.gray)
				pen.setWidthF(3.4)
				self.graph_item[tmp].setPen(pen)
				

class lineItem(QtGui.QGraphicsLineItem):

	def setParents(self,parentList,allItems):
		self.parentList = parentList
		self.selected=False
		self.allItems=allItems
		self.ctrlPressed=False
		self.backupPen=self.pen()
		self.setAcceptDrops(True)
		self.selectWidth = 2.5

	def testprint(self):
		print "I'm printable!"

	def mousePressEvent(self,args):
		if (self.isSelected() and self.isPressed()):			
			self.setSelected(False)
			for i in self.parentList:
				i.setSelected(False)
		elif(self.isSelected() and not self.isPressed()):
			for each in self.allItems:
				each.setSelected(False)
		elif(not self.isSelected() and self.isPressed()):
			self.setSelected(True)
			for i in self.parentList:
				i.setSelected(True)
		else:
			for each in self.allItems:
				each.setSelected(False)
			self.setSelected(True)
			for i in self.parentList:
				i.setSelected(True)
	def dragEnterEvent(self,event):
		print event
	
	def setPressed(self,key):
		#print "Yes"
		if(key==QtCore.Qt.Key_Control):
			self.ctrlPressed=True

	def setUnPressed(self,key):
		#print "No"
		if(key==QtCore.Qt.Key_Control):
			self.ctrlPressed=False

	def isSelected(self):
		return self.selected
	
	def isPressed(self):
		return self.ctrlPressed
	def setBackupPen(self,pen):
		self.backupPen = pen
	def getBackupPen(self):
		return self.backupPen

	def decreaseWidth(self):
		pen = self.pen()
		if(self.isSelected()):
			pen.setWidthF(pen.widthF()*1/1.05)
			self.selectWidth = pen.widthF()
			self.backupPen.setWidthF(self.backupPen.widthF()*1/1.05)
		else:
			pen.setWidthF(pen.widthF()*1/1.05)
			self.selectWidth = self.selectWidth*1/1.05
			self.backupPen = pen
		self.setPen(pen)

	def increaseWidth(self):
		pen = self.pen()
		if(self.isSelected()):
			pen.setWidthF(pen.widthF()*1.05)
			self.selectWidth = pen.widthF()
			self.backupPen.setWidthF(self.backupPen.widthF()*1.05)
		else:
			pen.setWidthF(pen.widthF()*1.05)
			self.selectWidth = self.selectWidth*1.05
			self.backupPen = pen
		self.setPen(pen)
	
	
	def setSelected(self,selection):
		pen = QtGui.QPen(QtCore.Qt.gray)
		pen.setStyle(QtCore.Qt.DotLine)
		pen.setWidthF(self.selectWidth)
		if (selection):
			self.setPen(pen)
		else:
			self.setPen(self.backupPen)
		self.selected=selection
